Travelling HDU - 3001 状压DP

Travelling

Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 7476    Accepted Submission(s): 2434


Problem Description
After coding so many days,Mr Acmer wants to have a good rest.So travelling is the best choice!He has decided to visit n cities(he insists on seeing all the cities!And he does not mind which city being his start station because superman can bring him to any city at first but only once.), and of course there are m roads here,following a fee as usual.But Mr Acmer gets bored so easily that he doesn't want to visit a city more than twice!And he is so mean that he wants to minimize the total fee!He is lazy you see.So he turns to you for help.
 

Input
There are several test cases,the first line is two intergers n(1<=n<=10) and m,which means he needs to visit n cities and there are m roads he can choose,then m lines follow,each line will include three intergers a,b and c(1<=a,b<=n),means there is a road between a and b and the cost is of course c.Input to the End Of File.
 

Output
Output the minimum fee that he should pay,or -1 if he can't find such a route.
 

Sample Input
  
  
2 1 1 2 100 3 2 1 2 40 2 3 50 3 3 1 2 3 1 3 4 2 3 10
 

Sample Output
  
  
100 90 7
 

Source
 

题目链接:https://vjudge.net/problem/POJ-3254
题意:一个人要旅行休假,给n个点,m条带权无向边,
    问这个人把每一个点都经过的最小花费。
    起点为任意点,但是每个点最多只能经过2次。
 
跟 POJ 3311   Hie with the Pie POJ 差不多,不过这里是每个点最多经过2次
因此状态就用3进制存,0 1 2 分别表示经过点0 1 2次
dp[S][i] 表示在状态S下,经过i点的最小花费(经过1次或2次)
dp[S][i] = min{ dp[S][i], dp[S - san[i - 1]][j] + dis[j][i] }
                                    j为状态S中经过的点 且 j != i
还有取状态S的3进制第i位的技巧是
    ( S / san[i - 1] ) % 3 , san[i - 1]为3^(i-1)


#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cstring>
#include <queue>
#include <string>
#define LL long long
#define inf 0x3f3f3f3f
#define INF 1e18
using namespace std;
typedef pair<int, int> P;
const int maxn = 6e4 + 5;
const int mod = 1e8;

int n, m;
int dp[maxn][11];
int dis[11][11];
int san[11]; // 题目问经过每个点不超过2次,因此用3进制存状态 
	// 0 1 2 表示经过点的次数 
int main(void)
{
//	std::ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
//	freopen("in.txt", "r", stdin);
	san[0] = 1;
	for (int i = 1; i <= 10; i++)
		san[i] = san[i - 1] * 3;
	int u, v, w;
	while (~scanf("%d %d", &n, &m)){
		memset(dis, inf, sizeof dis);
		for (int i = 1; i <= m; i++){
			scanf("%d %d %d", &u, &v, &w);
			dis[u][v] = min(dis[u][v], w);
			dis[v][u] = min(dis[v][u], w);
		}
		int ans = inf, passAll;
		for (int S = 0; S < san[n]; S++){
			passAll = 1;
			for (int i = 1; i <= n; i++){ // 判断当前状态是否经过了所有点 
				int cc = (S / san[i - 1]) % 3; // 获取S的三进制的第i-1位 
				if (cc == 0) passAll = 0;
			}
			for (int i = 1; i <= n; i++){
				int c = (S / san[i - 1]) % 3;
				if (c == 0) continue; // 如果S的三进制第i-1位为0,说明没有经过点i 
				if (S == san[i - 1] || S == san[i - 1] * 2)
					dp[S][i] = 0; //如果S经过点i,1次或2次,花费初始化为0 
				else {
					dp[S][i] = inf;
					for (int j = 1; j <= n; j++){
						int c2 = (S / san[j - 1]) % 3;
						if (c2 && i != j)
							dp[S][i] = min(dp[S][i], dp[S - san[i - 1]][j] + dis[j][i]);
					}
					if (passAll) ans = min(ans, dp[S][i]); // 当前S经过了所有点 
				}
			} 
		} 
		if (ans == inf) puts("-1");
		else printf("%d\n", ans);
	}

	return 0;
}




  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值